// University of Washington Bothell Graphics Library
// Authors: Kelvin Sung, Steve Baer
// The accompanying library supports CSS Graphics courses taught at UW-Bothell
// See: http://courses.washington.edu/css450/
//      http://courses.washington.edu/css451/
///////////////////////////////////////////////////////////////////////////////////
#pragma once
#include "GrfxWindowD3D.h"

/// Main dialog for the sample application. This is created and displayed in
/// the CTutorialApp::InitInstance function.
class CTutorialDlg : public CDialog
{
public:
  CTutorialDlg(CWnd* pParent = NULL);

  /// The IDD enum is a common technique in MFC to associate a dialog with
  /// a resource that you edit in the dialog editor
  enum { IDD = IDD_D3D_SIMPLESHADERS_DIALOG };

protected:
  /// Called immediately after a dialog is created, but before it is displayed.
  /// This is where all of the control initialization usually occurs. This is
  /// also where the graphics window is set up
  virtual BOOL OnInitDialog();

  virtual void DoDataExchange(CDataExchange* pDX);

  /// A message map is an MFC macro for mapping window's events (paint, size, mouse,...) that
  /// occur on a window to functions in this class.
  /// The functions in this class that begin with afx_msg are "handlers" for window's messages
  DECLARE_MESSAGE_MAP()
  afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
  afx_msg void OnBnClickedReset();
  afx_msg void OnBnClickedCameraZ0();

private:
  /// The window that displays Direct3D graphics.
  /// This is a child window of the dialog
  CGrfxWindowD3D m_GrfxWnd;

  HICON m_hIcon;
  UWBMFC_SliderCtrlWithEcho m_slider_camera_x;
  UWBMFC_SliderCtrlWithEcho m_slider_camera_y;
  UWBMFC_SliderCtrlWithEcho m_slider_camera_z;
  UWBMFC_SliderCtrlWithEcho m_slider_lookat_x;
  UWBMFC_SliderCtrlWithEcho m_slider_lookat_y;
  UWBMFC_SliderCtrlWithEcho m_slider_lookat_z;
  UWBMFC_SliderCtrlWithEcho m_slider_upvector;
  UWBMFC_SliderCtrlWithEcho m_slider_upvectorz;
  BOOL m_SpotOn;
  BOOL m_DirOn;
  BOOL m_PtOn;
  afx_msg void OnBnClickedPointLight();
  afx_msg void OnBnClickedDirectionalLight();
  afx_msg void OnBnClickedSpotLight();
};
