#include "uwbgl_D3DGraphicsSystem7.h"


bool UWBD3D_GraphicsSystem::ActivateTexture(const wchar_t* texFile, DWORD stage)
{
  UWBD3D_TextureResource* pTexture = FindTextureResource( texFile, true );
  if (NULL == pTexture)
      return false;
  
  // set up our texture stages for a simple texture copy...
  m_pD3DDevice->SetTextureStageState( stage, D3DTSS_COLOROP,   D3DTOP_SELECTARG1 );

  // Refer to the D3D help, the first parameter is a number (between 0 to something)
  // the second parameter can be ...
  //    D3DTSS_COLOROP
  //    D3DTSS_COLORARG1, ARG2
  //    D3DTSS_ALPHAARG1, ARG2
  //    D3DTSS_MAGFILTER, MINFILTER, MIPFILTER (more and more and tons tons more!!)
  // For Stage 0,
  //    Arg1 is the texture
  //    Arg2 is the color on the object
  // The third parameter can be
  //    D3DTA_TEXTURE
  //    D3DTA_DIFFUSE
  //    D3DTA_MODULATE
  //    D3DTA_SELECTARG1
  //    D3DTA_SELECTARG2 ... (more and more and tons tons more!!!)

  m_pD3DDevice->SetTextureStageState( stage, D3DTSS_ALPHAOP,   D3DTOP_SELECTARG1);
  // Now see, are setting the alpha channel in the texture stage, in this
  // case, we say, we _always_ want the alpha information from the file texture

  m_pD3DDevice->SetTexture(stage, pTexture->GetD3DTexture() );
  return true;
}

void UWBD3D_GraphicsSystem::DeactivateTexture( DWORD stage )
{
  if( NULL == m_pD3DDevice )
    return;

	// Is this the right way to deactivate texture?
	m_pD3DDevice->SetTexture(stage, NULL);

	// I think this is a better way to disable texture?
	m_pD3DDevice->SetTextureStageState( stage, D3DTSS_COLOROP, D3DTOP_DISABLE);
}