#include "uwbgl_PrimitiveRectXZ3.h"

UWB_PrimitiveRectangleXZ::UWB_PrimitiveRectangleXZ()
{
  m_bounds.SetCorners( vec3(0,0,0), vec3(0,0,0) );
}

void UWB_PrimitiveRectangleXZ::DrawPrimitive( eLevelOfDetail lod, UWB_DrawHelper& draw_helper )
{
  draw_helper.DrawRectangleXZ( m_bounds.GetMin(), m_bounds.GetMax() );
}

void UWB_PrimitiveRectangleXZ::MouseDownVertex(int vertexID, float x, float y)
{
  if(vertexID == 0)
  {
    m_mouse_down_point = vec3(x,0,y);
    m_bounds.SetCorners( m_mouse_down_point, m_mouse_down_point );
  }
  else
  {
    m_bounds.SetCorners( m_mouse_down_point, vec3(x,0,y) );
  }
}

void UWB_PrimitiveRectangleXZ::MoveTo(float x, float y)
{
  vec3 old_center = m_bounds.GetCenter();
  float dx = x-old_center.x;
  float dz = y-old_center.z;

  vec3 min_point = m_bounds.GetMin();
  vec3 max_point = m_bounds.GetMax();

  min_point.x += dx;
  min_point.z += dz;
  max_point.x += dx;
  max_point.z += dz;
  m_bounds.SetCorners( min_point, max_point );
}
